import c4d
from c4d import gui
import math
#Welcome to the world of Python

def main():
    #get active doc and object
    doc = c4d.documents.GetActiveDocument()
    op = doc.GetActiveObject()
    #if object selected isn't polygon object raise error
    if op.GetType() != 5100:
        gui.MessageDialog('Object non Polygonal !')
        return
    
    LightMatrix = c4d.Matrix()
    
    
    
    totalPoints = op.GetPointCount()
    #get the selection
    pointSelected =  op.GetPointS()
    #raise error if there's no 4 points selected
    if pointSelected.GetCount() != 4 :
        gui.MessageDialog('Selectionnez 4 points') 
        return
        
        
    pointList = pointSelected.GetAll(totalPoints)
    
    pointPos = []
    addition = c4d.Vector(0,0,0)
    
    #get point and center.
    for cpt in range(0,totalPoints):
        if pointList[cpt]:
            pointPos.append( op.GetPoint(cpt)* op.GetMg())
            addition += pointPos[-1]
    
    centerPoint = addition/4
    
    #build vector
    VectorAB = pointPos[0] - pointPos[1]
    VectorAC = pointPos[0] - pointPos[2]
    VectorAD = pointPos[0] - pointPos[3]

    #get the 2 smallers
    VectorLength = [VectorAB.GetLength(),VectorAC.GetLength(),VectorAD.GetLength()]
    if VectorLength[0]> VectorLength[1]  and VectorLength[0]>VectorLength[2]:
        Vector = [VectorAC,VectorAD]  
    elif  VectorLength[1] > VectorLength[0]  and VectorLength[1]>VectorLength[2]:
        Vector = [VectorAB, VectorAD]
    elif VectorLength[2] > VectorLength[0]  and VectorLength[2]>VectorLength[1]:    
        Vector = [VectorAB, VectorAC]
        
    #Depending on witch is longer, get height and width and vectors vor v1 and v2    
    if Vector[0].GetLength() > Vector[1].GetLength() :
        Height = Vector[0].GetLength()
        Width = Vector[1].GetLength()
        LightMatrix.v1 = Vector[1].GetNormalized()
        LightMatrix.v2 = Vector[0].GetNormalized()
 
    else:
        Height = Vector[1].GetLength()
        Width = Vector[0].GetLength()
        LightMatrix.v1 = Vector[0].GetNormalized()
        LightMatrix.v2 = Vector[1].GetNormalized()
     
    Vn = Vector[0].Cross(Vector[1])
    Vn.Normalize()
                
   
 

 

    LightMatrix.v3 = Vn
    LightMatrix.off = centerPoint
 
    doc.StartUndo()
    light = c4d.BaseObject(c4d.Olight)
    doc.InsertObject(light,pred=op)
    doc.AddUndo(c4d.UNDOTYPE_NEW, light) 

    light.SetMg(LightMatrix)
    light[c4d.LIGHT_TYPE]=8
    light[c4d.LIGHT_AREADETAILS_SIZEX] = Width
    light[c4d.LIGHT_AREADETAILS_SIZEY] = Height    
    doc.EndUndo()
    c4d.EventAdd()
if __name__=='__main__':
    main()
 
 
