import c4d
from c4d import gui
#Welcome to the world of Python


def _SetCamera(obj,polygon):
    
    bd = doc.GetActiveBaseDraw()
    if not bd :
        return False
    cam = bd.GetSceneCamera(doc)
    if not cam :
        cam = bd.GetEditorCamera()
        if not cam: 
            return False
    
    objMg = obj.GetMg()
    
    pA = obj.GetPoint(polygon.a)  * objMg
    pB = obj.GetPoint(polygon.b)  * objMg 
    pC = obj.GetPoint(polygon.c)  * objMg 
    pD = obj.GetPoint(polygon.d)  * objMg
    
   
    bary = ((pA + pB + pC + pD) * 0.25) 
   
   
    vAB = pB - pA
    vAC = pC - pA
    
    norm = vAB.Cross(vAC)
    norm.Normalize()
    
    camrot = c4d.utils.VectorToHPB(norm) 
    
    camdist = c4d.Vector(cam.GetRelPos() - bary).GetLength()
    campos = bary +  norm * camdist
    

    newmg = c4d.utils.HPBToMatrix (c4d.utils.VectorToHPB(-norm) )
    newmg.off = campos
     
    cam.SetMg(newmg)
    
    return True    


def main():
    
    docMode = doc.GetMode()
    """
    if docMode != c4d.Mpolygons :
        gui.MessageDialog('Vous devez être en mode polygone') 
        return 
    """        
    objects = doc.GetActiveObjectsFilter(False, c4d.Opolygon, c4d.NOTOK)
    if not objects:
        gui.MessageDialog("Selectionnez un objet")
        return
    
    selection =  c4d.BaseSelect()
    
    for obj in objects:
        selection = obj.GetPolygonS()
        if selection.GetCount() > 0:
            polynum = selection.GetAll(obj.GetPolygonCount()).index(1)        
            if not (_SetCamera (obj, obj.GetPolygon(polynum))):
                gui.MessageDialog("Une erreur s'est produite pendant le calcul")
            break
        
    if selection.GetCount() == 0:
        gui.MessageDialog('Selectionner un polygone')
         
   
    c4d.EventAdd()

if __name__=='__main__':
    main()
