import c4d
from c4d import gui
#Welcome to the world of Python


def main():
    msg = c4d.BaseContainer()
    lightTtype = 0
    
    c4d.gui.GetInputState(c4d.BFM_INPUT_KEYBOARD, c4d.BFM_INPUT_CHANNEL, msg)
    if msg.GetLong(c4d.BFM_INPUT_QUALIFIER) & c4d.QCTRL:
        lightTtype = 1
    if msg.GetLong(c4d.BFM_INPUT_QUALIFIER) & c4d.QSHIFT:
        lightTtype = 8
    if msg.GetLong(c4d.BFM_INPUT_QUALIFIER) & c4d.QALT:
        lightTtype = 3
        
        
    doc = c4d.documents.GetActiveDocument()
    bd = doc.GetActiveBaseDraw()
    camMatrix = bd.GetMg()
    doc.StartUndo()

    light = c4d.BaseObject(c4d.Olight)
    doc.InsertObject(light)
    doc.AddUndo(c4d.UNDOTYPE_NEW, light)
    
    doc.AddUndo(c4d.UNDOTYPE_CHANGE, light)    
    light.SetMg(camMatrix)

    doc.AddUndo(c4d.UNDOTYPE_CHANGE,light)    
    light[c4d.LIGHT_TYPE]=lightTtype
   
    doc.SetActiveObject(light)
    doc.EndUndo()
    
    
    c4d.EventAdd()
   

if __name__=='__main__':
    main()
